package {
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.utils.ByteArray;
	import flash.filters.*;


	public class Mandel extends Sprite
	{
		private static const xmax:Number = 2.;
		private static const xmin:Number = -2.;
		private static const xs0:int = 512;
		private static const ymax:Number = 2.;
		private static const ymin:Number = -2.;
		private static const ys0:int = 512;
		private static const rep:int = 256;

		public function Mandel()
		{
			var x:int;
			var y:int;
			var level:int;
/*			for(level = 0; level < 3; level++)*/
			{
				level = 2;
				var xs:int = xs0 * (1<<level), ys:int = ys0 * (1<<level);
				var data:BitmapData = new BitmapData(xs, ys);
				for(y = 0; y < ys; y++) for(x = 0; x < xs; x++){
					var n:uint;
					var r:Number = 0, i:Number = 0, cr:Number = (Number)(x) * (xmax - xmin) / xs + xmin, ci:Number = (Number)(y) * (ymax - ymin) / ys + ymin;
					for(n = 0; n < rep && r * r + i * i < 4; n++){
						var or:Number = r;
						r = r * r - i * i + cr;
						i = 2 * or * i + ci;
					}
					data.setPixel(x, y, (uint)(n * 256 / rep));
				}
				var bmp:Bitmap = new Bitmap(data);
				bmp.smoothing = true;
				bmp.scaleX = (Number)(xs0) / xs;
				bmp.scaleY = (Number)(ys0) / ys;
				addChild(bmp);
			}
		}
	}
}
